# Copyright (C) 2006-2008 Red Hat, Inc.
#
# This program is free software; you can redistribute
# it and/or modify it under the terms of version 2 of the
# GNU General Public License as published by the
# Free Software Foundation.

from Variable import parse_variable
from ricci_defines import PROPS_TAG
import xml
import xml.dom

class PropsObject:
	def __init__(self):
		self.__vars = {}

	def add_prop(self, variable):
		self.__vars[variable.get_name()] = variable

	def get_prop(self, name):
		if name in self.__vars:
			return self.__vars[name].get_value()
		else:
			return None

	def get_props(self):
		return self.__vars

	def export_xml(self, doc, parent_node):
		props = doc.createElement(str(PROPS_TAG))
		parent_node.appendChild(props)
		for var in self.__vars:
			props.appendChild(self.__vars[var].export_xml(doc))
		return props

	def import_xml(self, parent_node):
		props = None
		for node in parent_node.childNodes:
			if node.nodeType == xml.dom.Node.ELEMENT_NODE:
				if node.nodeName == str(PROPS_TAG):
					props = node

		if props is None:
			return self

		for node in props.childNodes:
			try:
				var = parse_variable(node)
				self.__vars[var.get_name()] = var
			except:
				continue
		return self
